use chrono::Utc;
use domain::{dto::account::AuthenticateWithPassword, entities::account::Account};
use library::{db, resp::response::{ResErr, ResOK, ResResult}};


pub async fn authticate_with_password(req: AuthenticateWithPassword) -> ResResult<ResOK<(String, String)>> {
    let account = Account::find_with_password(req.username.unwrap(), req.password.unwrap(), db!()).await?;
    if account.is_none() {
        tracing::info!("登录用户失败，用户查询为空");
        return Err(ResErr::params("用户名或密码错误"));
    }
    let account = account.unwrap();
    if account.disable_time > Utc::now() {
        tracing::error!("账户已禁用");
        return Err(ResErr::auth("账户已禁用"));
    }

    Ok(ResOK(Some(("".to_string(), "".to_string()))))
}